

// GLOBAL SETUP
// Create three lists
  
// list without index
var plCLR = new PICKLIST(['Red','Blue','Green','Black','White','Yellow','Purple','Puce']);

// non-linear 'constants' as they might be defined to be used elsewhere
var DIR_N = 0;
var DIR_E = 90;
var DIR_S = 180;
var DIR_W = 270;
var plDIR = new PICKLIST(['North','East','South','West'],[DIR_N,DIR_E,DIR_S,DIR_W]);

// constants as they might be defined for combination
var COF_WHITE = 1;
var COF_SUGAR = 2;
var COF_LARGE = 4;
var COF_FROTH = 8
var plCOF = new PICKLIST(['White','With sugar','Large size','Frothy'],[COF_WHITE,COF_SUGAR,COF_LARGE,COF_FROTH]);
  
  
var PASS=false;
var FAIL=true;  

var  plSIMPLE = null;   // globals for testing looking up  
var  plLINEAR = null;
var  plSPARSE = null;
var  plODD    = null;
  

// Exercise the display functions
// ------------------------------
function FillDisplayTable(){
  var html = '<table class="table titleR1" id=demo border=1><tr>'+
    '<td style="width:25%">toString()</td>'+
    '<td>Select [West,90,White]</td>'+
    '<td>Radio (2)</td>'+
    '<td style="width:20%">Checkboxes<br>[White,Frothy]</td></tr>';
  html += DisplayRow(plCLR,1);
  html += DisplayRow(plDIR,2);
  html += DisplayRow(plCOF,3);
  html += '</tr></table>';
  $('div#demo').html(html);
}
function DisplayRow(Picklist,RowNum){
  var row = '\n<tr>\n<td>' + Picklist.toString() + '</td>'
           + '<td><select multiple size=5>' + Picklist.OptionsHtml(['West',90,'White']) + '</select></td>'
           + '<td>' + Picklist.RadioHtml(2,'foo'+RowNum.toString(),'') + '</td>'
           + '<td>' + Picklist.ChecksHtml(['White','Frothy'],'bar','<br>') + '</td></tr>'
  return row;
} 

// Exercise specific functions
function ExerciseMisc(){
  var html = '<i>Nothing stressful here</i><br>'; 
  html += '<b>GetItemString</b> Color(0) &rarr; '       + plCLR.GetItemString(0) +
                                 ' <span class="m1">Color(7)</span> &rarr; '       + plCLR.GetItemString(7) +
                                 ' <span class="m1">Direction(180)</span> &rarr; ' + plDIR.GetItemString(180) +
                                 ' <span class="m1">Coffee(8)</span> &rarr; '      + plCOF.GetItemString(8) + '<br>';
                                 
  html += '<b>GetItemConstant</b> Color("White") &rarr; '    + plCLR.GetItemConstant('White') +         
                                ' <span class="m1">Direction("East")</span> &rarr; ' + plDIR.GetItemConstant('East') +
                                ' <span class="m1">Coffee("Frothy")</span> &rarr; '  + plCOF.GetItemConstant('Frothy') + '<br>';
                                
  $('table#demo').after(html);
}

// =============
// T E S T I N G
// =============


// Wrap a function to trap thrown errors
// Returns a red string if the test didn't return the expected result
function DoTest(AFunction,ExpectToFail){
  try {
    output = AFunction();  // string response eg OK
    completed = true;
  }catch(err){
    output = '['+err.name+'] '+err.message; 
    completed = false;
  }
  var desiredOutcome = (completed==(! ExpectToFail));
  var cl = (desiredOutcome) ? 'ok' : 'bad';
  return '<span class=' + cl + '>'+output+'</span>';
}    

//  master test call
function DoAllTests(){
  TestsCon();   // constructor
  TestsLup();   // lookups
}  

// constructor tests  
function TestsCon(){
  // CONSTRUCTOR
  var html = '<ul>';
  html += '<li>CON.1 Empty string array :'        + DoTest(con1,FAIL);
  html += '<li>CON.2 One item string array :'     + DoTest(con2,PASS);
  html += '<li>CON.3 500 item string array :'     + DoTest(con3,PASS);
  html += '<li>CON.4 Duplicate strings :'         + DoTest(con4,FAIL);
  html += '<li>CON.5 Empty strings :'             + DoTest(con5,FAIL);
  html += '<li>CON.6 Numbers instead of strings :'+ DoTest(con6,FAIL);
  html += '<li>CON.7 Null in string array :'      + DoTest(con7,FAIL);
  html += '<li>CON.8 Undefined in string array :' + DoTest(con8,FAIL);
  html += '<li>CON.21 Empty constants array :'    + DoTest(con21,FAIL);
  html += '<li>CON.22 Bad length constants :'     + DoTest(con22,FAIL);
  html += '<li>CON.23 Undefined in constants :'   + DoTest(con23,FAIL);
  html += '<li>CON.24 NaN in constants :'         + DoTest(con24,FAIL);
  html += '<li>CON.25 Float in constants :'       + DoTest(con25,FAIL);
  html += '<li>CON.26 String in constants :'      + DoTest(con26,FAIL);
  html += '<li>CON.27 Duplicate in constants :'   + DoTest(con27,FAIL);
  html += '<li>CON.28 Sparse constants :'         + DoTest(con28,PASS);
  html += '</ul>';
  $('div#con').html(html);
}  

// lookup tests  
function TestsLup(){
  var html = '<ul>';
  html += '<li>LUP.0 Create working lists :'      + DoTest(lup0,PASS);
  html += '<li><b>GetItemConstant</b>';
  html += '<li>LUP.1a "three" = 2 :'      + DoTest(lup1a,PASS);
  html += '<li>LUP.1b "three" = 3 :'      + DoTest(lup1b,PASS);
  html += '<li>LUP.1c "three" = 300 :'    + DoTest(lup1c,PASS);
  html += '<li>LUP.1d "three" = 3 :'      + DoTest(lup1d,PASS);
  html += '<li>LUP.2a "foo"  :'           + DoTest(lup2a,FAIL);
  html += '<li>LUP.2b "foo"  :'           + DoTest(lup2b,FAIL);
  html += '<li>LUP.2c "foo"  :'           + DoTest(lup2c,FAIL);
  html += '<li>LUP.2d "foo"  :'           + DoTest(lup2d,FAIL);
  html += '<li>LUP.3  No argument :'      + DoTest(lup3,FAIL);  
  html += '<li>LUP.4  Numeric argument :' + DoTest(lup4,FAIL);
  html += '<li>LUP.5  Null string arg :'  + DoTest(lup5,FAIL);
  html += '<li>LUP.6  "THREE" :'          + DoTest(lup6,FAIL);
  
  html += '<li><b>GetItemString</b>';
  html += '<li>LUP.11a 2 = "three":'      + DoTest(lup11a,PASS);
  html += '<li>LUP.11b 3 = "three":'      + DoTest(lup11b,PASS);
  html += '<li>LUP.11c 600000 = "six":'   + DoTest(lup11c,PASS);
  html += '<li>LUP.11d 3 = "three":'      + DoTest(lup11d,PASS);
  html += '<li>LUP.12a -1 :'              + DoTest(lup12a,FAIL);
  html += '<li>LUP.12b 33 :'              + DoTest(lup12b,FAIL);
  html += '<li>LUP.12c 333 :'             + DoTest(lup12c,FAIL);
  html += '<li>LUP.12d -4 = "four":'      + DoTest(lup12d,PASS);
  html += '<li>LUP.12e 22:'               + DoTest(lup12e,FAIL);
  html += '<li>LUP.13 missing arg :'      + DoTest(lup13,FAIL);
  html += '<li>LUP.14 string arg :'       + DoTest(lup14,FAIL);
  html += '<li>LUP.15 floating arg :'     + DoTest(lup15,FAIL);
  
  
  html += '</ul>';
  $('div#lup').html(html);
}  


  
// ==============================  
// I N D I V I D U A L  T E S T S
// ==============================  
function con1(){  
  var pl = new PICKLIST([]);
  return 'OK';
}  

function con2(){  
  var pl = new PICKLIST(['single']);
  return 'OK';
}  

function con3(){  
  var a = [];
  for(var i=0;i<500;i++){a[i]=i.toString();}
  var pl = new PICKLIST(a);
  return 'OK';
}  

function con4(){  
  var pl = new PICKLIST(['one','two','three','one']);
  return 'OK';
}  
  
function con5(){  
  var pl = new PICKLIST(['','two','three','one']);
  return 'OK';
}  

function con6(){  
  var pl = new PICKLIST([1,2,3]);
  return 'OK';
}  

function con7(){  
  var pl = new PICKLIST(['one',null,'three']);
  return 'OK';
}  

function con8(){ 
  var a = [];
  a[0]='one';
  a[4]='two';  
  var pl = new PICKLIST(a);
  return 'OK';
}  

function con21(){  
  var pl = new PICKLIST(['one','two','three'],[]);
  return 'OK';
}  
function con22(){  
  var pl = new PICKLIST(['one','two','three'],[1,2,3,4]);
  return 'OK';
}  
function con23(){ 
  var c = [];
  c[0] = 1;
  c[2] = 3;
  var pl = new PICKLIST(['one','two','three'],c);
  return 'OK';
}  
function con24(){  
  var pl = new PICKLIST(['one','two','three'],[1,NaN,3]);
  return 'OK';
}  
function con25(){  
  var pl = new PICKLIST(['one','two','three'],[1,2.2,3]);
  return 'OK';
}  
function con26(){  
  var pl = new PICKLIST(['one','two','three'],[1,"2",3]);
  return 'OK';
}  
function con27(){  
  var pl = new PICKLIST(['one','two','three'],[1,2,1]);
  return 'OK';
}  
function con28(){  
  var pl = new PICKLIST(['one','two','three'],[1,2000 ,3000000]);
  return 'OK';
}  


function lup0(){
  var strings = ['one','two','three','four','five','six']; 
  plSIMPLE = new PICKLIST(strings);
  plLINEAR = new PICKLIST(strings,[1,2,3,7,8,9]);  
  plSPARSE = new PICKLIST(strings,[1,20,300,4000,50000,600000]);  
  plODD    = new PICKLIST(strings,[1,-2,3,-4,5000,-6000]);  
  return 'OK';
}  
// GetItemConstant
function lup1a(){return plSIMPLE.GetItemConstant('three').toString();}
function lup1b(){return plLINEAR.GetItemConstant('three').toString();}
function lup1c(){return plSPARSE.GetItemConstant('three').toString();}
function lup1d(){return plODD.GetItemConstant('three').toString();}
function lup2a(){return plSIMPLE.GetItemConstant('foo').toString();}
function lup2b(){return plLINEAR.GetItemConstant('foo').toString();}
function lup2c(){return plSPARSE.GetItemConstant('foo').toString();}
function lup2d(){return plODD.GetItemConstant('foo').toString();}
function lup3(){return plODD.GetItemConstant().toString();}
function lup4(){return plODD.GetItemConstant(2.34).toString();}
function lup5(){return plODD.GetItemConstant('').toString();}
function lup6(){return plODD.GetItemConstant('THREE').toString();}

// GetItemString
function lup11a(){return plSIMPLE.GetItemString(2);}
function lup11b(){return plLINEAR.GetItemString(3);}
function lup11c(){return plSPARSE.GetItemString(600000);}
function lup11d(){return plODD.GetItemString(3);}

function lup12a(){return plSIMPLE.GetItemString(-1);}
function lup12b(){return plLINEAR.GetItemString(33);}   // out of range indexed
function lup12c(){return plSPARSE.GetItemString(333);}
function lup12d(){return plODD.GetItemString(-4);}
function lup12e(){return plSIMPLE.GetItemString(22);}   // out of range not-indexed

function lup13(){return plODD.GetItemString();}
function lup14(){return plODD.GetItemString('foo');}
function lup15(){return plODD.GetItemString(5.5);}

